# ifndef COMMAND_LINE_H
   # define COMMAND_LINE_H

   # include "history.h"

   # define COMMAND_LINE_STRINGS
   #  ifdef COMMAND_LINE_STRINGS
      extern char * _confirm_str[];
      extern char * _search_rstr[];
      extern char * _set_str[];
      extern char * _color_theme_str[];
      extern char * _syntax_str[];

      extern int set_cardinal;
      extern int syntax_cardinal;
   # endif

   # define REPLY_CANCEL -1
   # define REPLY_YES     0
   # define REPLY_NO      1

   # define SEARCH_REPLACE_YES 0
   # define SEARCH_REPLACE_NO  1
   # define SEARCH_REPLACE_ALL 2

   # define SET_COLOR_THEME 0
   # define SET_SYNTAX      1
   # define SET_TAB         2

   extern void command_line_init();
   extern void command_line_copy(char * _str);
   extern void command_line_add(char *_str);
   extern void command_line_print(char * _str);
   extern void command_line_print_stop(char * _str);
   extern void command_line_echo(char * _str);
   extern void command_line_vprintf(char * _template, ...);
   extern void command_line_redraw();
   extern void command_line_redraw2();
   extern void command_line_clear();
   extern void command_line_back_to_stop();
   extern void command_line_backspace();
   extern void command_line_enter();
   extern void command_line_read();
   extern void command_line_read_number();
   extern void command_line_read(History * _history);
   extern int command_line_revolve(char * _revolve_str[], int start, int n);
# endif
