# ifndef CWRITE_H
   # define CWRITE_H

   # include <pwd.h>
   # include <shadow.h>
   # include "color_theme.h"

      // -- user data --
   extern passwd * _user_data;
   extern spwd * _user_spwd;
   extern char * _user_dir;
   extern char * _user_history;
   extern char * _user_preferences;
   extern char * _user_selection;

   # define USER_FILENAME_MAX 256

   struct Datachain
      { Datachain * _prev;
        Datachain * _next;
        char * _line;
        int size;
        int ordinal;
        int invisible;
        int selection_start;
        int selection_end;
      };
   # include "bookmark.h"

   struct Datasystem
      { Datachain * _datachain_first;
        Datachain * _datachain;
        Datachain * _datachain_last;
        char * _filename;
        int ordinal;
        int dataline_max_size;
        int dataline_offset;
        int cursor_y;
        int cursor_x;
        int status_register;
        Datachain * _datachain_detach_start;
        Datachain * _datachain_detach_end;
        int cursor_y_detach;
        Bookmark bookmark[BOOKMARK_CARDINAL];
        int bookmark_ordinal;
      };

   extern Datasystem * _datasystem;

      // -- color pairs --
   extern short header_color_pair;
   extern short status_color_pair;
   extern short screen_color_pair;
   extern short block_color_pair;
   extern short selection_color_pair;
   extern short search_color_pair;
   extern short browse_color_pair;

      // -- screen parameters --
   extern int screen_cols, screen_left, screen_right;
   extern int screen_lines, screen_top, screen_bottom;

      // -- lines --
   extern char * _command_line;
   extern char * _user_line;
   extern int command_line_stop;
   extern int command_line_size;
   extern char * _header_line;
   extern char * _status_line;
   
      // -- datasystem control --
   extern int datasystem_count;
   extern int datasystem_ordinal;
   
      // -- dataline --
   extern int dataline_start_size;
   extern int dataline_extend_size;
   
      // -- pointers to current datasystem --
   extern Datachain ** __datachain_first;
   extern Datachain ** __datachain;
   extern Datachain ** __datachain_last;
   extern char ** __filename;
   extern int * _dataline_offset;
   extern int * _cursor_y;
   extern int * _cursor_x;
   extern int * _status_register;
   extern Datachain ** __datachain_detach_start;
   extern Datachain ** __datachain_detach_end;
   
      // -- line ordinals --
   # define COMMAND_LINE 0
   # define HEADER_LINE  1
   # define STATUS_LINE  2

      // -- requests --
   extern bool exit_request;
   extern bool return_request;
   
      // -- miscellaneous --
   extern bool status_line_busy;
   
      // -- files --
   extern char * _help_filename;

      // -- blocks --
   # define BLOCK_NO_SYNTAX -2
   # define BLOCK_ERROR     -1
   # define BLOCK_NONE       0

# endif
