# ifndef CWRITE_DATASYSTEM_H
   # define CWRITE_DATASYSTEM_H

   # define TYPE_MODE    0x01
   # define INS_MODE     0x02
   # define MODIFY_STATE 0x04
   # define DETACH_STATE 0x08
   # define SCROLL_STATE 0x10
   
   # define DATASYSTEM_CARDINAL  10
   # define DATASYSTEM_SELECTION  0
   # define DATASYSTEM_FIRST      1
   # define DATASYSTEM_LAST  (DATASYSTEM_CARDINAL - 1)
   
   # define DATASYSTEM_FILENAME_MAX 80

   extern Datasystem * _datasystem_pointer[];
   extern int datasystem_ordinal_main;

   extern void datasystem_alloc();
   extern void datasystem_shift_right();
   extern void datasystem_shift_left();
   extern void datasystem_defrag();
   extern void datasystem_new();
   extern void datasystem_init(int dataline_max_size);
   extern void datasystem_set();

   extern void datasystem_verify();
   extern void datasystem_print();
   extern void datasystem_realloc();
# endif
